﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.FullScreenEvent;
	import flash.display.DisplayObject;
	import flash.utils.getTimer;
	
	public class Boussoler extends Sprite
	{
		private var col:uint = 10;
		private var line:uint = 10;
		private var angle:Number;
		
		private var tank:Tank;
		private var tanks:Array;
		private var targetInfos:Array;
		
		private var currentOne:Object;
		private var theAngle:int;
		
		private var theTime:Number;
		private var launchTime:Number;
		
		public function Boussoler()
		{
			buttonMode = true;
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			while(numChildren>0){
				var c:DisplayObject = getChildAt(0);
				removeChildAt(0);
				c = null;
			}
		}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			init();
		}
		private function init():void
		{
			tanks = [];
			targetInfos = [];
			
			var nbrl:Number = stage.stageWidth/col;
			var nbrh:Number = stage.stageHeight/line;
			
			for(var i:uint = 1; i < line; i++){
				for(var j:uint = 1; j < col; j++){
					tank = new Tank();
					tank.x = j * nbrl;
					tank.y = i * nbrh;
					tank.addEventListener(MouseEvent.CLICK, clickHandler);
					addChild(tank);
					tanks.push(tank);
				}
			}
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			currentOne = e.currentTarget;
			launchTime = getTimer();
			targetInfos = [];
			targetInfos = selectTarget();
			currentOne.addEventListener(Event.ENTER_FRAME,enterHandler);
			
			for(var i:uint = 0; i < tanks.length; i++) {
				tanks[i].removeEventListener(MouseEvent.CLICK, clickHandler);
			}
		}
		
		public function react():void
		{			
			currentOne = tanks[targetInfos[2]];
			tanks.splice(tanks.indexOf(currentOne), 1);
			
			if(tanks.length == 1) {
				var alone:Alone = new Alone();
				alone.x = stage.stageWidth / 2;
				alone.y = stage.stageHeight / 2;
				addChild(alone);
			}
			
			launchTime = getTimer();
			targetInfos = [];
			targetInfos = selectTarget();
			currentOne.addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		
		private function enterHandler(e:Event):void
		{
			graphics.clear();
			
			theTime = getTimer();
			
			var currentAngle:Number = currentOne.rotation + 180;
			var targetAngle:Number = (targetInfos[1] * (180 / Math.PI) + 90);
			
			if(theTime - launchTime > 100 && currentAngle >= targetAngle - 2 && currentAngle <= targetAngle + 2) {
				rocketFire(targetInfos[0]);
				currentOne.removeEventListener(Event.ENTER_FRAME,enterHandler);
			} else if(!currentOne.dead){
				currentOne.rotation += 2;
			}
		}
		
		private function selectTarget():Array
		{
			var targ:Object;
			var targs:Array = [];
			var dst:Number;
			var ind:uint;
			
			for(var k:uint = 0; k < tanks.length; k++) {
				if(tanks[k] != currentOne && !tanks[k].dead) {
					dst = getDist(tanks[k].x, tanks[k].y, currentOne.x, currentOne.y);
					targ = {"dist":dst, "ind":k};
					targs.push(targ);
				}
			}
			
			dst = targs[0].dist;
			ind = targs[0].ind;
			
			for (var i:int = 1; i < targs.length; i++) {
				if (targs[i].dist < dst) {
					dst = Math.round(targs[i].dist);
					ind = targs[i].ind;
				}
			}
			
			var ang:Number = getAngle(tanks[ind].x, tanks[ind].y, currentOne.x, currentOne.y);
			var target:Array = new Array(dst, ang, ind);
			
			return target;
		}
		
		private function getDist(_x1:Number, _y1:Number, _x2:Number, _y2:Number):Number
		{
			var dx:Number = _x1 - _x2;
           	var dy:Number = _y1 - _y2;
			var distance:Number = Math.sqrt((dx * dx) + (dy * dy));
			
			return distance;
		}
		
		private function getAngle(_x1:Number, _y1:Number, _x2:Number, _y2:Number):Number
		{
			var dx:Number = _x1 - _x2;
           	var dy:Number = _y1 - _y2;
			var angle:Number = Math.atan2(dy, dx);
			
			return angle;
		}
		
		private function rocketFire(_distTarg:Number):void
		{	
			currentOne.dead = true;
			currentOne.distTarg = _distTarg;
			currentOne.missile();
			react();
		}
		
	}
}

	import flash.display.Sprite;
	import flash.events.Event;

	class Tank extends Sprite
	{
		public var dead:Boolean = false;
		public var distTarg:Number;
		
		private var inc:int;
		
		public function Tank():void
		{
			graphics.lineStyle(1,0xffffff);
			graphics.beginFill(0x000000, 1);
			graphics.drawCircle(0, 0, 7);
			graphics.endFill();
			
			graphics.lineStyle(1, 0xff0000, 1);
			graphics.moveTo(0, 7);
			graphics.lineTo(0, 12);
		}
		
		public function missile():void
		{
			addEventListener(Event.ENTER_FRAME, enterHandler);
		}
		
		private function enterHandler(e:Event):void
		{
			inc++;
			
			graphics.clear();
			
			graphics.lineStyle(1,0xffffff);
			graphics.beginFill(0x000000, 1);
			graphics.drawCircle(0, 0, 7);
			graphics.endFill();
			
			graphics.lineStyle(1, 0xff0000, 1);
			graphics.moveTo(0, 7 + inc);
			graphics.lineTo(0, 12 + inc);
			
			if(12 + inc >= distTarg) {
				graphics.clear();
				removeEventListener(Event.ENTER_FRAME, enterHandler);
			}
		}
	}